;;pierre,  13 Nov 00 12:01, on trane:
;; html mode conf file, as recommanded by:
;;/usr/local/lib/xemacs-20.4/lisp/hm--html-menus/hm--html-configuration.el



;; use hm mode, unless its already car of the list:
;; (just to protect the list from growing on multiple evaluations)

(unless (equal (caar auto-mode-alist) "\\.html$")
  (setq auto-mode-alist
	(cons '("\\.html$" . hm--html-mode) auto-mode-alist))
  )


;; hook:

(defun handmade-html-hook()
  "custom made function, to fix some html mode misbehaviors"
  (setq indent-line-function 'hm--html-indent-line)
  )

(setq hm--html-mode-hook 'handmade-html-hook)

; hm--html-tag-name-alist redefined here, with some elts different
; from the definition fed with the package: li, p and td defined as one elt
; tag, so as to get the proper indentation.
; brought the whole definition, rather than learn how to change only part
; of the alist, and, btw, how cud we modify someth not defined yet?
; (this gets evaluated before the mode is loaded, man)

;; ON UPGRADING XEMACS, NEW VALUE MIGHT NEED TO BE TAKEN FROM
;; PACKAGE!!!!!pierre,  13 Nov 00 15:30

(setq hm--html-tag-name-alist
  '(("!--" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("!doctype" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("isindex" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (prompt)))
    ("base" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes (href))
     (:hm--html-optional-attributes nil))
    ("meta" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes (content))
     (:hm--html-optional-attributes (http-equiv name)))
    ("link" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (href rel rev title)))
    ("hr" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align noshade size width)))
    ("input" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes
      (type name value checked size maxlength src align)))
    ("img" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes (src))
     (:hm--html-optional-attributes
      (alt align height width border hspace vspace usemap ismap)))
    ("param" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes (name))
     (:hm--html-optional-attributes (value)))
    ("br" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (clear)))
    ("basefont" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes size))
    ("area" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes (alt))
     (:hm--html-optional-attributes (shape coords href nohref)))
    ("option" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (selected value)))

    ("html" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("head" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("body" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (bgcolor text link vlink alink background))
     )
    ("h1" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("h2" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("h3" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("h4" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("h5" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("h6" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("address" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("p" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("ul" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (type compact)))
    ("ol" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (type start compact)))
    ("dl" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (compact)))
    ("li" (:hm--html-one-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (type (value "ol"))))
    ("dt" (:hm--html-one-or-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("dd" (:hm--html-one-or-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("dir" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (compact)))
    ("menu" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (compact)))
    ("pre" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (width)))
    ("div" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("center" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("blockquote" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("form" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (action method enctype)))
    ("select" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes (name))
     (:hm--html-optional-attributes (size multiple)))
    ("textarea" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes (name rows cols))
     (:hm--html-optional-attributes nil))
    ("table" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes
      (align width border cellspacing cellpading)))
    ("caption" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align)))
    ("tr" (:hm--html-one-or-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (align valign)))
    ("th" (:hm--html-one-or-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes
      (nowrap rowspan colspan align valign width height)))
    ("td" (:hm--html-one-or-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes
      (nowrap rowspan colspan align valign width height)))
    ("tt" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("i" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("b" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("u" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("strike" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("big" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("small" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("sub" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("sup" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("em" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("strong" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("dfn" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("code" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("samp" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("kbd" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("var" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("cite" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("a" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (name href rel rev title)))
    ("applet" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes (code width height))
     (:hm--html-optional-attributes (codebase alt name align hspace vspace)))
    ("font" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes (size color)))
    ("map" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes (name))
     (:hm--html-optional-attributes nil))
    ("style" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ("script" (:hm--html-two-element-tag t)
     (:hm--html-required-attributes nil)
     (:hm--html-optional-attributes nil))
    ))

;; custom variables; these are defined as defcustom in "default" file,
;; and get values from these files, unless defined here. Many arbitrary
;; or silly mode behaviors can be fixed by giving these variables better
;; defauts.

;; any use?
(setq hm--html-mailto-alist "info@dataspark.com")

(setq hm--html-inter-tag-indent 2)
(setq hm--html-comment-indent 5)
(setq hm--html-intra-tag-indent 2)

