;; lyx-mode.el: edit .lyx files.
;; pmi,  22 Jun 99 13:51: begins at quite low level

(setq  lyx-font-lock-keywords
  (list
   '("^\\\\[a-z_][a-z_]*"  . font-lock-keyword-face)
   '("^#.*$" . font-lock-comment-face)
   ))

;;; by default, paragraphs have the noindent attribute. Undef or set to nil otherwise:
(defvar lyx-noindent t)

(defun lyx-mode ()
  
  (interactive)
  ;; set up local variables
  (kill-all-local-variables)
  (make-local-variable 'fill-prefix)
  (make-local-variable 'paragraph-separate)
  (make-local-variable 'paragraph-start)

  ;;
  (setq
    major-mode             'lyx-mode
	mode-name              "Lyx"
    fill-prefix            " "
	paragraph-separate     "^\\.*$"
	paragraph-start        "^\\.*$"

	)
  (use-local-map lyx-mode-map)
  (auto-fill-mode t)
  (abbrev-mode t)
  )


;; after mode map change, eval this:
(if nil (makunbound 'lyx-mode-map)
  )
(defvar lyx-mode-map ()
  "Keymap used in `lyx-mode' buffers.")

;;in case U change these: just exec eval-current-buffer, or eval-last-sexp
;;(C-X C-E): map is unique session-wide, will be redone, no big deal
;;pmi,  30 Jun 99 16:31

(setq lyx-mode-map (make-sparse-keymap))

  ;; BAW - you could do it this way, but its not considered proper
  ;; major-mode form.
(mapcar (function
         (lambda (x)
           (define-key lyx-mode-map (car x) (cdr x))))
        '(
          ("\M-pi"  . lyx-paragraph-itemize)
          ("\M-pn"  . lyx-paragraph-enumerate)
          ("\M-ps"  . lyx-paragraph-standard)
          ("\M-pS"  . lyx-paragraph-section)
          ("\M-pu"  . lyx-paragraph-subsection)
          ("\M-pd"  . lyx-paragraph-description)
          ("\C-c\C-hm" . lyx-describe-mode)
          ))
;; should do all keybindings this way
(define-key lyx-mode-map "\C-c\C-b" 'lyx-submit-bug-report)
(define-key lyx-mode-map "\C-c\C-v" 'lyx-version)



(defun lyx-paragraph(Type)
  "opens a new paragraph"
  (end-of-line)
  (newline)
  (insert "\\end_layout ")
  (newline)
  (insert (concat "\\begin_layout " Type))
  (newline)
  (if (and
       (boundp 'lyx-noindent) (equal lyx-noindent t) (equal Type "Standard"))
      (progn
	(insert "\\noindent ")
	(newline)
	)
    )
  )

(defun lyx-paragraph-standard ()
  ""
  (interactive)
  (lyx-paragraph "Standard")
  )


(defun lyx-paragraph-itemize ()
  ""
  (interactive)
  (lyx-paragraph "Itemize")
  )

(defun lyx-paragraph-enumerate ()
  ""
  (interactive)
  (lyx-paragraph "Enumerate")
  )

(defun lyx-paragraph-description ()
  ""
  (interactive)
  (lyx-paragraph "Description")
  )



(defun lyx-paragraph-section ()
  ""
  (interactive)
  (lyx-paragraph "Section")
  )


(defun lyx-paragraph-subsection ()
  ""
  (interactive)
  (lyx-paragraph "Subsection")
  )

(defalias 'lyx-protected-separator
  (read-kbd-macro "<M-right> C-d RET \\protected_separator C-n C-p RET"))
