; customization file, called from .emacs imbaud,  4 Jun  97 13:11

;; got rid of python-info pmi,  22 Jun 99 10:40
;; added pdb load
(autoload 'python-mode "~/.emacs-custom/python-mode" "Python editing mode." t)
(setq auto-mode-alist
      (cons '("\\.py$" . python-mode) auto-mode-alist))

(autoload 'pdb "~/.emacs-custom/pdb" "Python debugger." t)

;; If you want font-lock support for Python source code (a.k.a. syntax
;; coloring, highlighting), add this to your .emacs file:
;;
;;     (add-hook 'python-mode-hook 'turn-on-font-lock)


;;Python Library Reference Hot-Key Help System for XEmacs
;(or PLRHKHSX for short ;), version 1.1.

(defun my-python-mode-common-hook ()
  ;; add my personal style and set it for the current buffer
  (turn-on-font-lock)
  (line-number-mode t)
  (define-key py-mode-map [f1] 'py-libindex-lookup-word-at-point) 
  (define-key py-mode-map "\C-m" 'newline-and-indent))

(add-hook 'python-mode-hook 'my-python-mode-common-hook)
; Hot key help for Python
; Set the following two variables to point to library document
; root and indexfile.  Note that py-lib-docroot can be a link to a
; local directory, or to http directory.
(setq py-lib-docroot "http://www.python.org/doc/lib/")
(setq py-lib-docroot "file:/export/home/pmi/python/1.5/lib/")
(setq py-lib-docindex "/export/home/pmi/.emacs-custom/PyLibLookup-1.1/pylib15.idx")

; We use the browse-url package to do the hard work for us
(autoload 'browse-url-at-point "browse-url"
   "Ask a WWW browser to load the URL at or before point." t)
(autoload 'browse-url-of-buffer "browse-url"
   "Ask a WWW browser to display BUFFER." t)

;
; Then some elisp magic, could be cleaner
; A function to take the word at point and display HTML help on it.
;
(defun py-libindex-lookup-word-at-point ()
  (interactive)
  (save-excursion
     (let ((end) (word) (cmd) (buf))
      (forward-word 1)
      (setq end (point))
      (backward-word 1)
      (setq word (buffer-substring end (point)))
      (if (get-buffer "*lookup result*")
          (kill-buffer "*lookup result*"))
      (setq buf (get-buffer-create "*lookup result*"))
      (call-process "indexlookup.py" nil buf nil word 
                    py-lib-docroot py-lib-docindex)
      (set-buffer buf)
      (if (> (count-lines (point-min) (point-max)) 4)
          (browse-url-of-buffer buf)
        (search-backward ":/")
        (browse-url-at-point)))))

