;; ================
;;stamps
;; ================

(require 'time-stamp)

(defun stamp-in-buffer ()
  "insert timestamp in the buffer, where point is"
  (interactive) 
  (mapcar 'insert (list (getenv "LOGNAME")  ",  "
                               (date-iso8601)) )
  )

(defun date-in-buffer ()
  "insert date in the buffer, where point is"
  (interactive) 
  (insert (medium-date))
  )

;; 1977-04-22T01:00:00-05:00
(defconst format-iso8601-short "%04y-%02m-%02d"  "iso8601 compliant short date format")
(defconst format-iso8601 (concat format-iso8601-short "T%02I:%02M:%02S") "iso8601 compliant date format")
(defconst format-classic "%02d/%02m/%04y")
;; 2007-06-27T21:19:31


(defun date-iso8601 (&optional longue)
  "Return the current date as a string in \"YYYY-MM-DD\" form. (short iso format, long if longue)"
    (time-stamp-string (if longue format-iso8601 format-iso8601-short))
    )

(defun datiso-in-buffer (&optional longue)
  "insert date iso8601 in the buffer, where point is"
  (interactive) 
  (insert (date-iso8601 longue))
  )

(defun rst-datiso (&optional longue)
  "insert date iso8601 in the, hopefully, rst buffer, where point is"
  (interactive) 
  (insert (concat ":date: " (date-iso8601 longue)))
  )
